<?php
/*
Plugin Name: templatePlugin
Plugin URI: http://www.adjust.ne.jp
Description: テンプレート振り分けプラグイン
Author: ADjust Co.,Ltd.
Author URI: http://www.adjust.ne.jp
Version: 1.0
*/

function getViewType()
{
  $ua = $_SERVER['HTTP_USER_AGENT'];

  return preg_match('/(iPhone|Android)/', $ua) ? 'sp' : 'pc';
}

add_filter('template_include', 'homeTemplateFilter');

function homeTemplateFilter($file)
{
  $template = basename($file);

  $templates = array(
    sprintf('%s_%s.php', basename($template, '.php'), getViewType()),
    $template
  );

  return locate_template($templates);
}

function get_header_custom( $name = null ) {
  $templates = array();
  $name = (string) $name;
  if ( '' !== $name )
  {
    $templates[] = sprintf('header-%s_%s.php', $name, getViewType());
    $templates[] = "header-{$name}.php";
  }

  $templates[] = sprintf('header_%s.php', getViewType());
  $templates[] = 'header.php';

  if ('' == locate_template($templates, true))
    load_template( ABSPATH . WPINC . '/theme-compat/header.php');
}

function get_footer_custom( $name = null ) {
  $templates = array();
  $name = (string) $name;
  if ( '' !== $name )
  {
    $templates[] = sprintf('footer-%s_%s.php', $name, getViewType());
    $templates[] = "footer-{$name}.php";
  }

  $templates[] = sprintf('footer_%s.php', getViewType());
  $templates[] = 'footer.php';

  if ('' == locate_template($templates, true))
    load_template( ABSPATH . WPINC . '/theme-compat/footer.php');
}

function get_sidebar_custom( $name = null ) {
  $templates = array();
  $name = (string) $name;
  if ( '' !== $name )
  {
    $templates[] = sprintf('sidebar-%s_%s.php', $name, getViewType());
    $templates[] = "sidebar-{$name}.php";
  }

  $templates[] = sprintf('sidebar_%s.php', getViewType());
  $templates[] = 'sidebar.php';

  if ('' == locate_template($templates, true))
    load_template( ABSPATH . WPINC . '/theme-compat/sidebar.php');
}

function get_template_part_custom( $slug, $name = null ) {
  $templates = array();
  $name = (string) $name;
  if ( '' !== $name )
  {
    $templates[] = sprintf('%s-%s_%s.php', $slug, $name, getViewType());
    $templates[] = "{$slug}-{$name}.php";
  }

  $templates[] = sprintf('%s_%s.php', $slug, getViewType());
  $templates[] = "{$slug}.php";

  locate_template($templates, true, false);
}